﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TestView.Ensaios;
using TestView.Ensaios.Utilidades;
using ModuloEnsaioTracao.Ensaios;
using TestView.Ensaios.Utilidades.CorposDeProva;
using ModuloEnsaioTracao.Ensaios.CorposDeProva;
using TestView.MyMath;
using TestView.Utils;
using TestView.Seguranca;
using System.Windows.Forms.DataVisualization.Charting;
using TestViewGUI.Relatorios;

namespace ModuloEnsaioTracao.GUI
{
    public partial class FormEnsaio : Form
    {
        #region Construtor e membros

        private List<ToolStripMenuItem> _menus;
        private IModuloDeEnsaio _moduloEnsaio;
        private ModuloEnsaioTracao ModuloEnsaioTracao
        {
            get
            {
                return (ModuloEnsaioTracao)this._moduloEnsaio;
            }
        }
        private ModuloTracaoGUI ModuloTracaoGUI
        {
            get
            {
                return (ModuloTracaoGUI)this.ModuloEnsaioTracao.FachadaGUI;
            }
        }
        private EnsaioTracao EnsaioTracao
        {
            get
            {
                return (EnsaioTracao)this.ModuloEnsaioTracao.RotinaDeEnsaio.Ensaio;
            }
        }
        private RotinaDeEnsaioTracao RotinaEnsaioTracao
        {
            get
            {
                return (RotinaDeEnsaioTracao)this._moduloEnsaio.RotinaDeEnsaio;
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Axis EixoAbscissa
        {
            get
            {
                return this.chartEnsaioTracao.ChartAreas[0].AxisX;
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Axis EixoSecundarioAbscissa
        {
            get
            {
                return this.chartEnsaioTracao.ChartAreas[0].AxisX2;
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Axis EixoOrdenada
        {
            get
            {
                return this.chartEnsaioTracao.ChartAreas[0].AxisY;
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Axis EixoSecundarioOrdenada
        {
            get
            {
                return this.chartEnsaioTracao.ChartAreas[0].AxisY2;
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Series SeriePrincipal
        {
            get
            {
                return this.chartEnsaioTracao.Series[0];
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Series SerieModuloElasticidade
        {
            get
            {
                return this.chartEnsaioTracao.Series[1];
            }
        }
        private System.Windows.Forms.DataVisualization.Charting.Series SerieParalelaModulo
        {
            get
            {
                return this.chartEnsaioTracao.Series[2];
            }
        }
        public Panel PainelEnsaio
        {
            get
            {
                return this.painelEnsaio;
            }
        }
        public Chart Grafico
        {
            get
            {
                return this.chartEnsaioTracao;
            }
        }
        public List<ToolStripMenuItem> Menus
        {
            get
            {
                return this._menus;
            }
        }

        public FormEnsaio(IModuloDeEnsaio moduloEnsaio)
        {
            InitializeComponent();
            this._menus = new List<ToolStripMenuItem>() { 
                this.opcoesToolStripMenuItem, 
                this.dadosToolStripMenuItem,
                this.relatorioToolStripMenuItem,
                this.ferramentasToolStripMenuItem, 
            };
            this._moduloEnsaio = moduloEnsaio;
            this.desenhaInformaoesAdicionais();
            this.desenhaFormularioCorpoDeProva();
            this.preencheComboboxCorpoProva();
            this.selecionaComboboxCorpoProva();
            this.atualizaLabelIniciarEnsaio();
            this.redesenhaDadosEnsaio();
            this.redesenhaGrafico();
            this.EnsaioTracao.EstadoEnsaioChanged += new Ensaio.EstadoEnsaioChangedEvent(estadoEnsaioChanged);
            this.EnsaioTracao.CorpoDeProvaChanged += new Ensaios.EnsaioTracao.CorpoDeProvaChangedEvent(EnsaioTracao_CorpoDeProvaChanged);
            this.EnsaioTracao.InformacoesAdicionaisChanged += new Ensaios.EnsaioTracao.InformacoesAdicionaisChangedEvent(EnsaioTracao_InformacoesAdicionaisChanged);
            this.EnsaioTracao.Grafico.GraficoChanged += new Graficos.GraficoEnsaioTracao.GraficoChangedEvent(graficoChanged);
            this.EnsaioTracao.ForcaMaximaChanged += new Ensaios.EnsaioTracao.ForcaMaximaChangedEvent(EnsaioTracao_ForcaMaximaChanged);
            this.EnsaioTracao.VelocidadeForcaChanged += new Ensaios.EnsaioTracao.VelocidadeForcaChangedEvent(EnsaioTracao_VelocidadeForcaChanged);
            this.EnsaioTracao.VelocidadeTensaoChanged += new Ensaios.EnsaioTracao.VelocidadeTensaoChangedEvent(EnsaioTracao_VelocidadeTensaoChanged);
            this.EnsaioTracao.VelocidadeDeslocamentoChanged += new Ensaios.EnsaioTracao.VelocidadeDeslocamentoChangedEvent(EnsaioTracao_VelocidadeDeslocamentoChanged);
            this.EnsaioTracao.ExtensometroRemovidoChanged += new Ensaios.EnsaioTracao.ExtensometroRemovidoEvent(EnsaioTracao_ExtensometroRemovidoChanged);
            this.EnsaioTracao.TensaoEscoamentoChanged += new Ensaios.EnsaioTracao.TensaoEscoamentoChangedEvent(EnsaioTracao_TensaoEscoamentoChanged);
            this.EnsaioTracao.ModuloElasticidadeChanged += new Ensaios.EnsaioTracao.ModuloElasticidadeChangedEvent(EnsaioTracao_ModuloElasticidadeChanged);
            this.EnsaioTracao.TensaoMaximaChanged += new Ensaios.EnsaioTracao.TensaoMaximaChangedEvent(EnsaioTracao_TensaoMaximaChanged);
        }

        #endregion

        #region Atualização

        private void atualizaLabelIniciarEnsaio()
        {
            this.atualizaLabelIniciarEnsaio(this.RotinaEnsaioTracao.EstadoDoEnsaio);
        }

        private void atualizaLabelIniciarEnsaio(EstadoEnsaio estadoEnsaio)
        {
            switch (estadoEnsaio)
            {
                case EstadoEnsaio.NAO_INICIADO:
                    this.setLabelDetails(this.labelIniciarEnsaio, Properties.Resources.iniciarEnsaioString, true, Cursors.Hand);
                    break;
                case EstadoEnsaio.INICIADO:
                    this.setLabelDetails(this.labelIniciarEnsaio, Properties.Resources.encerrarEnsaioString, true, Cursors.Hand);
                    break;
                default:
                    this.setLabelDetails(this.labelIniciarEnsaio, Properties.Resources.iniciarEnsaioString, false, Cursors.Default);
                    break;
            }
        }

        #endregion

        #region Grafico

        private void redesenhaGrafico()
        {
            EnsaioTracao ensaio = this.RotinaEnsaioTracao.EnsaioTracao;
            this.atualizaSerieChart(this.chartEnsaioTracao, this.SeriePrincipal, ensaio.Grafico.SeriePrincipalValoresAbscissa, ensaio.Grafico.SeriePrincipalValoresOrdenada);
            this.atualizaSerieChart(this.chartEnsaioTracao, this.SerieModuloElasticidade, ensaio.Grafico.SerieModuloElasticidadeValoresAbscissa, ensaio.Grafico.SerieModuloElasticidadeValoresOrdenada);
            this.atualizaSerieChart(this.chartEnsaioTracao, this.SerieParalelaModulo, ensaio.Grafico.SerieParalelaModuloValoresAbscissa, ensaio.Grafico.SerieParalelaModuloValoresOrdenada);
            this.atualizaTituloEixoChart(this.chartEnsaioTracao, this.EixoAbscissa, ensaio.Grafico.TituloAbscissa);
            this.atualizaTituloEixoChart(this.chartEnsaioTracao, this.EixoOrdenada, ensaio.Grafico.TituloOrdenada);
        }

        #endregion

        #region Informacoes adicionais

        private void desenhaInformaoesAdicionais()
        {
            int indice = 0;
            bool informacoesSomenteLeitura = false;
            if (this.EnsaioTracao.EstadoEnsaio == EstadoEnsaio.FECHADO)
            {
                informacoesSomenteLeitura = true;
            }
            const int DISTANCIA_CABECALHO = 10;
            const int DISTANCIA_ELEMENTOS = 3;
            const int DISTANCIA_INFORMACOES = 4;
            const int MARGEM_ESQUERDA_LABEL = 3;
            const int MARGEM_ESQUERDA_TEXTBOX = 6;
            const int LARGURA_TEXTBOX = 164;
            const int ALTURA_TEXTBOX = 20;
            const int LARGURA_LABEL = 164;
            const int ALTURA_LABEL = 13;
            EnsaioTracao ensaio = this.EnsaioTracao;
            painelInformacoesAdicionais.Controls.Clear();
            for (indice = 0; indice < ensaio.InformacoesAdicionais.Count; indice++)
            {
                InformacaoAdicional informacao = ensaio.InformacoesAdicionais[indice];

                Label labelInformacao = new Label();
                labelInformacao.AutoSize = false;
                labelInformacao.Size = new Size(LARGURA_LABEL, ALTURA_LABEL);
                labelInformacao.Location = new Point(MARGEM_ESQUERDA_LABEL, DISTANCIA_CABECALHO + indice * (ALTURA_LABEL + ALTURA_TEXTBOX + DISTANCIA_ELEMENTOS + DISTANCIA_INFORMACOES));
                labelInformacao.Text = informacao.Informacao;
                labelInformacao.Tag = informacao;

                TextBox textboxInformacao = new TextBox();
                textboxInformacao.Size = new Size(LARGURA_TEXTBOX, ALTURA_TEXTBOX);
                textboxInformacao.Location = new Point(MARGEM_ESQUERDA_TEXTBOX, DISTANCIA_CABECALHO + indice * (ALTURA_LABEL + ALTURA_TEXTBOX + DISTANCIA_ELEMENTOS + DISTANCIA_INFORMACOES) + ALTURA_LABEL + DISTANCIA_ELEMENTOS);
                textboxInformacao.ReadOnly = informacoesSomenteLeitura;
                textboxInformacao.Text = informacao.Valor;
                textboxInformacao.Tag = informacao;
                textboxInformacao.TextChanged += new EventHandler(textboxInformacaoAdicionalChanged);

                painelInformacoesAdicionais.Controls.Add(labelInformacao);
                painelInformacoesAdicionais.Controls.Add(textboxInformacao);
            }
        }

        private void textboxInformacaoAdicionalChanged(object sender, EventArgs e)
        {
            TextBox textboxInformacao = (TextBox)sender;
            InformacaoAdicional informacao = (InformacaoAdicional)textboxInformacao.Tag;

            this.RotinaEnsaioTracao.salvaInformacaoAdicional(informacao, textboxInformacao.Text);
        }

        #endregion

        #region Dados do ensaio

        private void redesenhaDadosEnsaio()
        {
            this.atualizaForcaMaxima();
            this.atualizaTensaoMaxima();
            this.atualizaVelocidadeInstantaneaForca();
            this.atualizaVelocidadeInstantaneaTensao();
            this.atualizaVelocidadeInstantaneaDeslocamento();
            this.atualizaTensaoEscoamento();
            this.atualizaModuloElasticidade();
        }

        private void atualizaForcaMaxima()
        {
            this.atualizaForcaMaxima(this.EnsaioTracao.ForcaMaxima);
        }

        private void atualizaForcaMaxima(double forcaMaxima)
        {
            String forcaMaximaString = String.Empty;
            if (double.IsNaN(forcaMaxima))
            {
                forcaMaximaString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeForca = this.EnsaioTracao.SerieForca.Calibracao.Unidade;
                forcaMaximaString = String.Format("{0} {1}", forcaMaxima, unidadeForca);
            }
            this.setLabelDetails(this.labelForcaMaxima, forcaMaximaString, true, Cursors.Default);
        }

        private void atualizaTensaoMaxima()
        {
            this.atualizaTensaoMaxima(this.EnsaioTracao.TensaoMaxima);
        }

        private void atualizaTensaoMaxima(double tensaoMaxima)
        {
            String tensaoMaximaString = String.Empty;
            if (double.IsNaN(tensaoMaxima))
            {
                tensaoMaximaString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeTensao = this.EnsaioTracao.UnidadeTensaoMaxima;
                tensaoMaximaString = String.Format("{0:0.00} {1}", tensaoMaxima, unidadeTensao);
            }
            this.setLabelDetails(this.labelTensaoMaxima, tensaoMaximaString, true, Cursors.Default);
        }

        private void atualizaVelocidadeInstantaneaForca()
        {
            this.atualizaVelocidadeInstantaneaForca(this.EnsaioTracao.VelocidadeInstantaneaForca);
        }

        private void atualizaVelocidadeInstantaneaForca(double velocidadeForca)
        {
            String velocidadeForcaString = String.Empty;
            if (double.IsNaN(velocidadeForca))
            {
                velocidadeForcaString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeVelocidadeForca = this.EnsaioTracao.UnidadeVelocidadeForca;
                velocidadeForcaString = String.Format("{0:0.00} {1}", velocidadeForca, unidadeVelocidadeForca);
            }
            this.setLabelDetails(this.labelVelocidadeForca, velocidadeForcaString, true, Cursors.Default);
        }

        private void atualizaVelocidadeInstantaneaTensao()
        {
            this.atualizaVelocidadeInstantaneaTensao(this.EnsaioTracao.VelocidadeInstantaneaTensao);
        }

        private void atualizaVelocidadeInstantaneaTensao(double velocidadeTensao)
        {
            String velocidadeTensaoString = String.Empty;
            if (double.IsNaN(velocidadeTensao))
            {
                velocidadeTensaoString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeVelocidadeTensao = this.EnsaioTracao.UnidadeVelocidadeTensao;
                velocidadeTensaoString = String.Format("{0:0.00} {1}", velocidadeTensao, unidadeVelocidadeTensao);
            }
            this.setLabelDetails(this.labelVelocidadeTensao, velocidadeTensaoString, true, Cursors.Default);
        }

        private void atualizaVelocidadeInstantaneaDeslocamento()
        {
            this.atualizaVelocidadeInstantaneaDeslocamento(this.EnsaioTracao.VelocidadeInstantaneaDeslocamento);
        }

        private void atualizaVelocidadeInstantaneaDeslocamento(double velocidadeDeslocamento)
        {
            String velocidadeDeslocamentoString = String.Empty;
            if (double.IsNaN(velocidadeDeslocamento))
            {
                velocidadeDeslocamentoString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeVelocidadeDeslocamento = this.EnsaioTracao.UnidadeVelocidadeDeslocamento;
                velocidadeDeslocamentoString = String.Format("{0:0.00} {1}", velocidadeDeslocamento, unidadeVelocidadeDeslocamento);
            }
            this.setLabelDetails(this.labelVelocidadeDeslocamento, velocidadeDeslocamentoString, true, Cursors.Default);
        }

        private void atualizaTensaoEscoamento()
        {
            this.atualizaTensaoEscoamento(this.EnsaioTracao.TensaoEscoamento);
        }

        private void atualizaTensaoEscoamento(double tensaoEscoamento)
        {
            String tensaoEscoamentoString = String.Empty;
            if (double.IsNaN(tensaoEscoamento))
            {
                tensaoEscoamentoString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeTensaoEscoamento = this.EnsaioTracao.UnidadeTensaoEscoamento;
                tensaoEscoamentoString = String.Format("{0:0.00} {1}", tensaoEscoamento, unidadeTensaoEscoamento);
            }
            this.setLabelDetails(this.labelTensaoEscoamento, tensaoEscoamentoString, true, Cursors.Default);
        }

        private void atualizaModuloElasticidade()
        {
            this.atualizaModuloElasticidade(this.EnsaioTracao.ModuloDeElasticidade);
        }

        private void atualizaModuloElasticidade(double moduloElasticidade)
        {
            String moduloElasticidadeString = String.Empty;
            if (double.IsNaN(moduloElasticidade))
            {
                moduloElasticidadeString = Properties.Resources.indicacaoVaziaString;
            }
            else
            {
                Unidade unidadeModuloElasticidade = this.EnsaioTracao.UnidadeTensaoEscoamento;
                Unidade unidadeModuloElasticidadeDestino = Unidade.GPA;
                moduloElasticidade = Conversor.converterTensao(moduloElasticidade, unidadeModuloElasticidade, unidadeModuloElasticidadeDestino);
                moduloElasticidadeString = String.Format("{0:0.00} {1}", moduloElasticidade, unidadeModuloElasticidadeDestino);
            }
            this.setLabelDetails(this.labelModuloElasticidade, moduloElasticidadeString, true, Cursors.Default);
        }

        #endregion

        #region Corpo de prova

        private void preencheComboboxCorpoProva()
        {
            this.comboBoxSeccaoCorpoProva.Items.Clear();
            CorpoDeProva[] seccoes = new CorpoDeProva[]{
                new Quadrado(),
                new Plano(),
                new Cilindrico()
            };
            this.comboBoxSeccaoCorpoProva.Items.AddRange(seccoes);
        }

        private void selecionaComboboxCorpoProva()
        {
            foreach (object seccao in this.comboBoxSeccaoCorpoProva.Items)
            {
                if (seccao.GetType().Equals(this.EnsaioTracao.CorpoDeProva.GetType()))
                {
                    this.comboBoxSeccaoCorpoProva.SelectedItem = seccao;
                }
            }
        }

        private void selecionaCorpoDeProva()
        {
            CorpoDeProva seccao = (CorpoDeProva)this.comboBoxSeccaoCorpoProva.SelectedItem;
            this.RotinaEnsaioTracao.selecionaCorpoDeProva(seccao);
        }

        private void desenhaFormularioCorpoDeProva()
        {
            int itens = 0, margem = 9, separacao = 6, altura = 20;
            bool informacoesSomenteLeitura = true;
            if (this.EnsaioTracao.EstadoEnsaio == EstadoEnsaio.NAO_INICIADO)
            {
                informacoesSomenteLeitura = false;
            }
            this.comboBoxSeccaoCorpoProva.Enabled = !informacoesSomenteLeitura;
            List<Control> controlesFormularioCorpoProva = new List<Control>();
            CorpoDeProva corpoDeProva = this.EnsaioTracao.CorpoDeProva;
            if (corpoDeProva.GetType().Equals(typeof(Cilindrico)))
            {
                Cilindrico cp = (Cilindrico)corpoDeProva;
                this.setPictureboxDetails(this.pictureBoxCorpoProva, Properties.Resources.circular);
                #region Diametro
                Label labelDiametro = new Label();
                labelDiametro.Size = new Size(50, altura);
                labelDiametro.AutoSize = false;
                labelDiametro.Location = new Point(3, margem + itens * (altura + separacao));
                labelDiametro.TextAlign = ContentAlignment.MiddleRight;
                labelDiametro.Text = Properties.Resources.diametroSimboloString;

                TextBox textboxDiametro = new TextBox();
                textboxDiametro.Size = new Size(68, altura);
                textboxDiametro.Location = new Point(59, margem + itens * (altura + separacao));
                textboxDiametro.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxDiametro.ReadOnly = informacoesSomenteLeitura;
                textboxDiametro.Text = cp.DiametroOriginal.ToString();
                textboxDiametro.Validating += new CancelEventHandler(textboxNumericoNaoNuloValidating);
                textboxDiametro.Validated += new EventHandler(textboxDiametroCilindricoValidated);

                Label labelUnidadeDiametro = new Label();
                labelUnidadeDiametro.Size = new Size(45, altura);
                labelUnidadeDiametro.AutoSize = false;
                labelUnidadeDiametro.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeDiametro.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeDiametro.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeDiametro.Text = Unidade.MM.ToString();

                controlesFormularioCorpoProva.Add(labelDiametro);
                controlesFormularioCorpoProva.Add(textboxDiametro);
                controlesFormularioCorpoProva.Add(labelUnidadeDiametro);
                itens++;
                #endregion
                #region Área
                Label labelArea = new Label();
                labelArea.Size = new Size(50, altura);
                labelArea.AutoSize = false;
                labelArea.Location = new Point(3, margem + itens * (altura + separacao));
                labelArea.TextAlign = ContentAlignment.MiddleRight;
                labelArea.Text = Properties.Resources.areaString;

                TextBox textboxArea = new TextBox();
                textboxArea.Name = "textboxArea";
                textboxArea.Size = new Size(68, altura);
                textboxArea.Location = new Point(59, margem + itens * (altura + separacao));
                textboxArea.ReadOnly = true;
                textboxArea.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxArea.Text = String.Format("{0:0.000}", cp.AreaEquivalente);
                cp.CorpoDeProvaChanged += new CorpoDeProva.CorpoDeProvaChangedEvent(corpoDeProvaChanged);

                Label labelUnidadeArea = new Label();
                labelUnidadeArea.Size = new Size(45, altura);
                labelUnidadeArea.AutoSize = false;
                labelUnidadeArea.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeArea.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeArea.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeArea.Text = Unidade.MM2.ToString();

                controlesFormularioCorpoProva.Add(labelArea);
                controlesFormularioCorpoProva.Add(textboxArea);
                controlesFormularioCorpoProva.Add(labelUnidadeArea);
                itens++;
                #endregion
            }
            else if (corpoDeProva.GetType().Equals(typeof(Plano)))
            {
                Plano cp = (Plano)corpoDeProva;
                this.setPictureboxDetails(this.pictureBoxCorpoProva, Properties.Resources.plano);
                #region Base
                Label labelBase = new Label();
                labelBase.Size = new Size(50, altura);
                labelBase.AutoSize = false;
                labelBase.Location = new Point(3, margem + itens * (altura + separacao));
                labelBase.TextAlign = ContentAlignment.MiddleRight;
                labelBase.Text = Properties.Resources.larguraPlanoSimboloString;

                TextBox textboxBase = new TextBox();
                textboxBase.Size = new Size(68, altura);
                textboxBase.Location = new Point(59, margem + itens * (altura + separacao));
                textboxBase.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxBase.ReadOnly = informacoesSomenteLeitura;
                textboxBase.Text = cp.Base.ToString();
                textboxBase.Validating += new CancelEventHandler(textboxNumericoNaoNuloValidating);
                textboxBase.Validated += new EventHandler(textboxBasePlanoValidated);

                Label labelUnidadeBase = new Label();
                labelUnidadeBase.Size = new Size(45, altura);
                labelUnidadeBase.AutoSize = false;
                labelUnidadeBase.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeBase.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeBase.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeBase.Text = Unidade.MM.ToString();

                controlesFormularioCorpoProva.Add(labelBase);
                controlesFormularioCorpoProva.Add(textboxBase);
                controlesFormularioCorpoProva.Add(labelUnidadeBase);
                itens++;
                #endregion
                #region Altura
                Label labelAltura = new Label();
                labelAltura.Size = new Size(50, altura);
                labelAltura.AutoSize = false;
                labelAltura.Location = new Point(3, margem + itens * (altura + separacao));
                labelAltura.TextAlign = ContentAlignment.MiddleRight;
                labelAltura.Text = Properties.Resources.alturaPlanoSimboloString;

                TextBox textboxAltura = new TextBox();
                textboxAltura.Size = new Size(68, altura);
                textboxAltura.Location = new Point(59, margem + itens * (altura + separacao));
                textboxAltura.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxAltura.ReadOnly = informacoesSomenteLeitura;
                textboxAltura.Text = cp.Altura.ToString();
                textboxAltura.Validating += new CancelEventHandler(textboxNumericoNaoNuloValidating);
                textboxAltura.Validated += new EventHandler(textboxAlturaPlanoValidated);

                Label labelUnidadeAltura = new Label();
                labelUnidadeAltura.Size = new Size(45, altura);
                labelUnidadeAltura.AutoSize = false;
                labelUnidadeAltura.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeAltura.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeAltura.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeAltura.Text = Unidade.MM.ToString();

                controlesFormularioCorpoProva.Add(labelAltura);
                controlesFormularioCorpoProva.Add(textboxAltura);
                controlesFormularioCorpoProva.Add(labelUnidadeAltura);
                itens++;
                #endregion
                #region Área
                Label labelArea = new Label();
                labelArea.Size = new Size(50, altura);
                labelArea.AutoSize = false;
                labelArea.Location = new Point(3, margem + itens * (altura + separacao));
                labelArea.TextAlign = ContentAlignment.MiddleRight;
                labelArea.Text = Properties.Resources.areaString;

                TextBox textboxArea = new TextBox();
                textboxArea.Name = "textboxArea";
                textboxArea.Size = new Size(68, altura);
                textboxArea.Location = new Point(59, margem + itens * (altura + separacao));
                textboxArea.ReadOnly = true;
                textboxArea.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxArea.Text = String.Format("{0:0.000}", cp.AreaEquivalente);
                cp.CorpoDeProvaChanged += new CorpoDeProva.CorpoDeProvaChangedEvent(corpoDeProvaChanged);

                Label labelUnidadeArea = new Label();
                labelUnidadeArea.Size = new Size(45, altura);
                labelUnidadeArea.AutoSize = false;
                labelUnidadeArea.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeArea.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeArea.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeArea.Text = Unidade.MM2.ToString();

                controlesFormularioCorpoProva.Add(labelArea);
                controlesFormularioCorpoProva.Add(textboxArea);
                controlesFormularioCorpoProva.Add(labelUnidadeArea);
                itens++;
                #endregion
            }
            else if (corpoDeProva.GetType().Equals(typeof(Quadrado)))
            {
                Quadrado cp = (Quadrado)corpoDeProva;
                this.setPictureboxDetails(this.pictureBoxCorpoProva, Properties.Resources.quadrado);
                #region Lado
                Label labelLado = new Label();
                labelLado.Size = new Size(50, altura);
                labelLado.AutoSize = false;
                labelLado.Location = new Point(3, margem + itens * (altura + separacao));
                labelLado.TextAlign = ContentAlignment.MiddleRight;
                labelLado.Text = Properties.Resources.ladoQuadradoSimboloString;

                TextBox textboxLado = new TextBox();
                textboxLado.Size = new Size(68, altura);
                textboxLado.Location = new Point(59, margem + itens * (altura + separacao));
                textboxLado.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxLado.ReadOnly = informacoesSomenteLeitura;
                textboxLado.Text = cp.Lado.ToString();
                textboxLado.Validating += new CancelEventHandler(textboxNumericoNaoNuloValidating);
                textboxLado.Validated += new EventHandler(textboxLadoQuadradoValidated);

                Label labelUnidadeLado = new Label();
                labelUnidadeLado.Size = new Size(45, altura);
                labelUnidadeLado.AutoSize = false;
                labelUnidadeLado.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeLado.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeLado.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeLado.Text = Unidade.MM.ToString();

                controlesFormularioCorpoProva.Add(labelLado);
                controlesFormularioCorpoProva.Add(textboxLado);
                controlesFormularioCorpoProva.Add(labelUnidadeLado);
                itens++;
                #endregion
                #region Área
                Label labelArea = new Label();
                labelArea.Size = new Size(50, altura);
                labelArea.AutoSize = false;
                labelArea.Location = new Point(3, margem + itens * (altura + separacao));
                labelArea.TextAlign = ContentAlignment.MiddleRight;
                labelArea.Text = Properties.Resources.areaString;

                TextBox textboxArea = new TextBox();
                textboxArea.Name = "textboxArea";
                textboxArea.Size = new Size(68, altura);
                textboxArea.Location = new Point(59, margem + itens * (altura + separacao));
                textboxArea.ReadOnly = true;
                textboxArea.Anchor = AnchorStyles.Left & AnchorStyles.Top & AnchorStyles.Right;
                textboxArea.Text = String.Format("{0:0.000}", cp.AreaEquivalente);
                cp.CorpoDeProvaChanged += new CorpoDeProva.CorpoDeProvaChangedEvent(corpoDeProvaChanged);

                Label labelUnidadeArea = new Label();
                labelUnidadeArea.Size = new Size(45, altura);
                labelUnidadeArea.AutoSize = false;
                labelUnidadeArea.Location = new Point(133, margem + itens * (altura + separacao));
                labelUnidadeArea.TextAlign = ContentAlignment.MiddleLeft;
                labelUnidadeArea.Anchor = AnchorStyles.Top & AnchorStyles.Right;
                labelUnidadeArea.Text = Unidade.MM2.ToString();

                controlesFormularioCorpoProva.Add(labelArea);
                controlesFormularioCorpoProva.Add(textboxArea);
                controlesFormularioCorpoProva.Add(labelUnidadeArea);
                itens++;
                #endregion
            }
            else
            {
                this.setPictureboxDetails(this.pictureBoxCorpoProva, null);
            }
            this.setPanelDetails(this.painelDetalhesCorpoProva, controlesFormularioCorpoProva.ToArray());
        }

        private void setDiametroCilindrico(string valorTexto)
        {
            Double valor = double.Parse(valorTexto);
            Cilindrico cp = (Cilindrico)this.EnsaioTracao.CorpoDeProva;
            cp.DiametroOriginal = valor;
        }

        private void setBasePlano(string valorTexto)
        {
            Double valor = double.Parse(valorTexto);
            Plano cp = (Plano)this.EnsaioTracao.CorpoDeProva;
            cp.Base = valor;
        }

        private void setAlturaPlano(string valorTexto)
        {
            Double valor = double.Parse(valorTexto);
            Plano cp = (Plano)this.EnsaioTracao.CorpoDeProva;
            cp.Altura = valor;
        }

        private void setLadoQuadrado(string valorTexto)
        {
            Double valor = double.Parse(valorTexto);
            Quadrado cp = (Quadrado)this.EnsaioTracao.CorpoDeProva;
            cp.Lado = valor;
        }

        private void atualizaTextboxArea(CorpoDeProva cp)
        {
            foreach (Control control in this.painelDetalhesCorpoProva.Controls)
            {
                if (control.Name.Equals("textboxArea"))
                {
                    TextBox textboxArea = (TextBox)control;
                    textboxArea.Text = String.Format("{0:0.0000}", cp.AreaEquivalente);
                }
            }
        }

        #endregion

        #region Delegates

        private delegate void SetLabelDetailsCallBack(Label label, string texto, bool habilitado, System.Windows.Forms.Cursor cursor);

        private void setLabelDetails(Label label, string texto, bool habilitado, System.Windows.Forms.Cursor cursor)
        {
            if (label.InvokeRequired)
            {
                SetLabelDetailsCallBack d = new SetLabelDetailsCallBack(setLabelDetails);
                try
                {
                    label.Invoke(d, new object[] { label, texto, habilitado, cursor });
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            else
            {
                label.Text = texto;
                label.Enabled = habilitado;
                label.Cursor = cursor;
            }
        }

        private delegate void SetPictureboxDetailsCallBack(PictureBox picturebox, Image imagem);

        private void setPictureboxDetails(PictureBox picturebox, Image imagem)
        {
            if (picturebox.InvokeRequired)
            {
                SetPictureboxDetailsCallBack d = new SetPictureboxDetailsCallBack(setPictureboxDetails);
                try
                {
                    picturebox.Invoke(d, new object[] { picturebox, imagem });
                }
                catch (ObjectDisposedException) { }
            }
            else
            {
                picturebox.Image = imagem;
            }
        }

        private delegate void SetPanelDetailsCallBack(Panel panel, Control[] controles);

        private void setPanelDetails(Panel panel, Control[] controles)
        {
            if (panel.InvokeRequired)
            {
                SetPanelDetailsCallBack d = new SetPanelDetailsCallBack(setPanelDetails);
                try
                {
                    panel.Invoke(d, new object[] { panel, controles });
                }
                catch (ObjectDisposedException) { }
            }
            else
            {
                panel.Controls.Clear();
                panel.Controls.AddRange(controles);
            }
        }

        private delegate void AtualizaEixoGrafioDetails(Chart grafico, Axis eixo, Double maximo);

        private void atualizaEixoGraficoDetails(Chart grafico, Axis eixo, Double maximo)
        {
            if (grafico.InvokeRequired)
            {
                AtualizaEixoGrafioDetails d = new AtualizaEixoGrafioDetails(atualizaEixoGraficoDetails);
                try
                {
                    grafico.Invoke(d, new object[] { grafico, eixo, maximo });
                }
                catch (ObjectDisposedException) { }
            }
            else
            {
                eixo.Maximum = maximo;
            }
        }

        #region Delegates para Chart

        #region Serie

        private delegate void AtualizaSerieChartCallBack(System.Windows.Forms.DataVisualization.Charting.Chart grafico, System.Windows.Forms.DataVisualization.Charting.Series serie, List<Double> valoresX, List<Double> valoresY);

        private void atualizaSerieChart(System.Windows.Forms.DataVisualization.Charting.Chart grafico, System.Windows.Forms.DataVisualization.Charting.Series serie, List<Double> valoresX, List<Double> valoresY)
        {
            if (grafico.InvokeRequired)
            {
                AtualizaSerieChartCallBack d = new AtualizaSerieChartCallBack(atualizaSerieChart);
                try
                {
                    grafico.Invoke(d, new object[] { grafico, serie, valoresX, valoresY });
                }
                catch (Exception ex)
                {
                    Logging.getInstance().warn(ex.Message, ex, false);
                }
            }
            else
            {
                serie.Points.DataBindXY(valoresX, valoresY);
            }
        }

        #endregion

        #region Eixo

        private delegate void AtualizaTituloEixoChartCallBack(System.Windows.Forms.DataVisualization.Charting.Chart grafico, System.Windows.Forms.DataVisualization.Charting.Axis eixo, String titulo);

        private void atualizaTituloEixoChart(System.Windows.Forms.DataVisualization.Charting.Chart grafico, System.Windows.Forms.DataVisualization.Charting.Axis eixo, String titulo)
        {
            if (grafico.InvokeRequired)
            {
                AtualizaTituloEixoChartCallBack d = new AtualizaTituloEixoChartCallBack(atualizaTituloEixoChart);
                try
                {
                    grafico.Invoke(d, new object[] { grafico, eixo, titulo });
                }
                catch (Exception ex)
                {
                    Logging.getInstance().warn(ex.Message, ex, false);
                }
            }
            else
            {
                eixo.Title = titulo;
            }
        }

        #endregion

        #endregion

        #endregion

        #region Eventos

        private void labelIniciarEnsaio_Click(object sender, EventArgs e)
        {
            Label labelAlternarEnsaio = (Label)sender;
            labelAlternarEnsaio.Focus();
            this.RotinaEnsaioTracao.alternaEstadoEnsaio();
        }

        private void graficoChanged(object sender, Graficos.GraficoEnsaioTracao.GraficoChangedEventArgs e)
        {
            this.redesenhaGrafico();
        }

        private void estadoEnsaioChanged(object sender, Ensaio.EstadoEnsaioEventArgs e)
        {
            this.atualizaLabelIniciarEnsaio(e.EstadoEnsaio);
            this.desenhaFormularioCorpoDeProva();
        }

        private void opcoesDeGraficoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormOpcoesDeGrafico form = new FormOpcoesDeGrafico(this._moduloEnsaio);
            form.ShowDialog();
        }

        private void guardarModeloToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.RotinaEnsaioTracao.usarEnsaioComoModelo();
        }

        private void corpoDeProvaChanged(object sender, CorpoDeProva.CorpoDeProvaChangedEventArgs e)
        {
            CorpoDeProva cp = (CorpoDeProva)sender;
            this.atualizaTextboxArea(cp);
        }

        private void comboBoxSeccaoCorpoProva_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecionaCorpoDeProva();
        }

        private void EnsaioTracao_CorpoDeProvaChanged(object sender, EnsaioTracao.CorpoDeProvaChangedEventArgs e)
        {
            this.desenhaFormularioCorpoDeProva();
            this.selecionaComboboxCorpoProva();
        }

        private void informacoesAdicionaisToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormInformacoesAdicionais form = new FormInformacoesAdicionais(this._moduloEnsaio);
            form.ShowDialog();
        }

        private void opcoesDeEnsaioToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormOpcoesDeEnsaio form = new FormOpcoesDeEnsaio(this._moduloEnsaio);
            form.ShowDialog();
        }

        private void EnsaioTracao_InformacoesAdicionaisChanged(object sender, EnsaioTracao.InformacoesAdicionaisChangedEventArgs e)
        {
            this.desenhaInformaoesAdicionais();
        }

        private void EnsaioTracao_ForcaMaximaChanged(object sender, EnsaioTracao.ForcaMaximaChangedEventArgs e)
        {
            this.atualizaForcaMaxima(e.ForcaMaxima);
        }

        private void EnsaioTracao_VelocidadeForcaChanged(object sender, EnsaioTracao.VelocidadeForcaChangedEventArgs e)
        {
            this.atualizaVelocidadeInstantaneaForca(e.VelocidadeForca);
        }

        private void EnsaioTracao_VelocidadeTensaoChanged(object sender, EnsaioTracao.VelocidadeTensaoChangedEventArgs e)
        {
            this.atualizaVelocidadeInstantaneaTensao(e.VelocidadeTensao);
        }

        private void EnsaioTracao_VelocidadeDeslocamentoChanged(object sender, EnsaioTracao.VelocidadeDeslocamentoChangedEventArgs e)
        {
            this.atualizaVelocidadeInstantaneaDeslocamento(e.VelocidadeDeslocamento);
        }

        private void EnsaioTracao_TensaoEscoamentoChanged(object sender, EnsaioTracao.TensaoEscoamentoChangedEventArgs e)
        {
            this.atualizaTensaoEscoamento(e.TensaoEscoamento);
        }

        private void EnsaioTracao_TensaoMaximaChanged(object sender, EnsaioTracao.TensaoMaximaChangedEventArgs e)
        {
            this.atualizaTensaoMaxima(e.TensaoMaxima);
        }

        private void EnsaioTracao_ModuloElasticidadeChanged(object sender, EnsaioTracao.ModuloElasticidadeChangedEventArgs e)
        {
            this.atualizaModuloElasticidade(e.ModuloElasticidade);
        }

        private void EnsaioTracao_ExtensometroRemovidoChanged(object sender, EnsaioTracao.ExtensometroRemovidoEventArgs e)
        {
            FormRemoverExtensometro form = new FormRemoverExtensometro();
            form.ShowDialog();
        }

        private void opcoesDoRelatorioToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormOpcoesDoRelatorio form = new FormOpcoesDoRelatorio(this._moduloEnsaio);
            form.ShowDialog();
        }

        private void visualizarRelatorioToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormVisualizarRelatorio form = new FormVisualizarRelatorio(this._moduloEnsaio);
            form.Show();
        }

        #region Validacao

        private void alternarAlertaValidacaoTextbox(TextBox textbox, string textoDica, bool alerta)
        {
            if (alerta)
            {
                textbox.BackColor = Color.LightSalmon;
                dica.Show(textoDica, textbox, textbox.Width, -20, 3000);
                textbox.SelectAll();
            }
            else
            {
                textbox.BackColor = SystemColors.Window;
            }
        }

        private void textboxNumericoNaoNuloValidating(object sender, CancelEventArgs e)
        {
            TextBox textbox = (TextBox)sender;
            string texto = textbox.Text;
            if (Validacao.validaTextoNumerico(texto))
            {
                if (!Validacao.validaValorNaoNulo(texto))
                {
                    e.Cancel = true;
                    this.alternarAlertaValidacaoTextbox(textbox, Properties.Resources.validaNumericoNaoNuloString, true);
                }
                else
                {
                    this.alternarAlertaValidacaoTextbox(textbox, null, false);
                }
            }
            else
            {
                e.Cancel = true;
                this.alternarAlertaValidacaoTextbox(textbox, Properties.Resources.validaNumericoNaoNuloString, true);
            }
        }

        private void textboxDiametroCilindricoValidated(object sender, EventArgs e)
        {
            TextBox textboxDiametro = (TextBox)sender;
            this.setDiametroCilindrico(textboxDiametro.Text);
        }

        private void textboxBasePlanoValidated(object sender, EventArgs e)
        {
            TextBox textboxBase = (TextBox)sender;
            this.setBasePlano(textboxBase.Text);
        }

        private void textboxAlturaPlanoValidated(object sender, EventArgs e)
        {
            TextBox textboxAltura = (TextBox)sender;
            this.setAlturaPlano(textboxAltura.Text);
        }

        private void textboxLadoQuadradoValidated(object sender, EventArgs e)
        {
            TextBox textboxLado = (TextBox)sender;
            this.setLadoQuadrado(textboxLado.Text);
        }

        #endregion

        #endregion
    }
}
