﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using System.Windows.Forms;
using ModuloEnsaioTracao.GUI;
using System.Windows.Forms.DataVisualization.Charting;
using System.IO;
using System.Drawing;

namespace ModuloEnsaioTracao
{
    public class ModuloTracaoGUI : IModuloGUI
    {
        private FormEnsaio _formEnsaio;
        private ModuloEnsaioTracao _moduloEnsaio;

        public ModuloTracaoGUI(ModuloEnsaioTracao modulo)
        {
            this._moduloEnsaio = modulo;
        }

        public Panel PainelEnsaio
        {
            get
            {
                if (this._formEnsaio == null)
                {
                    this._formEnsaio = new FormEnsaio(this._moduloEnsaio);
                }
                return this._formEnsaio.PainelEnsaio;
            }
        }
        public Form FormRelatorio
        {
            get
            {
                FormRelatorioEnsaioTracao form = new FormRelatorioEnsaioTracao(this._moduloEnsaio);
                return form;
            }
        }
        private Chart Grafico
        {
            get
            {
                return this._formEnsaio.Grafico;
            }
        }
        public Image ImagemGrafico
        {
            get
            {
                if (this.Grafico != null)
                {
                    Stream imagemStream = new MemoryStream();
                    this.Grafico.SaveImage(imagemStream, ChartImageFormat.Jpeg);
                    Image imagem = new Bitmap(imagemStream);
                    return imagem;
                }
                else
                {
                    return null;
                }
            }
        }
        public double MaximoOrdenada
        {
            get
            {
                return this.Grafico.ChartAreas[0].AxisY.Maximum;
            }
        }
        public double MaximoAbscissa
        {
            get
            {
                return this.Grafico.ChartAreas[0].AxisX.Maximum;
            }
        }
        public double MinimoOrdenada
        {
            get
            {
                return this.Grafico.ChartAreas[0].AxisY.Minimum;
            }
        }
        public double MinimoAbscissa
        {
            get
            {
                return this.Grafico.ChartAreas[0].AxisX.Minimum;
            }
        }

        public List<ToolStripMenuItem> Menus
        {
            get
            {
                if (this._formEnsaio == null)
                {
                    this._formEnsaio = new FormEnsaio(this._moduloEnsaio);
                }
                return this._formEnsaio.Menus;
            }
        }
    }
}
