﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Relatorios;
using ModuloEnsaioTracao.Ensaios;

namespace ModuloEnsaioTracao.Relatorios
{
    public class RelatorioODTEnsaioTracao : RelatorioODT
    {
        private Dictionary<String, byte[]> _items;
        private EnsaioTracao _ensaio;

        public override byte[] Manifest
        {
            get
            {
                {
                    string manifest = @"<?xml version=""1.0"" encoding=""UTF-8""?>
<manifest:manifest xmlns:manifest=""urn:oasis:names:tc:opendocument:xmlns:manifest:1.0"" manifest:version=""1.2"">
    <manifest:file-entry manifest:media-type=""application/vnd.oasis.opendocument.text"" manifest:version=""1.2"" manifest:full-path=""/""/>
    <manifest:file-entry manifest:media-type=""text/xml"" manifest:full-path=""content.xml""/>
    <manifest:file-entry manifest:media-type=""text/xml"" manifest:full-path=""meta.xml"" />
    <manifest:file-entry manifest:media-type=""text/xml"" manifest:full-path=""styles.xml"" />
</manifest:manifest>";
                    byte[] manifestArray = Encoding.UTF8.GetBytes(manifest);
                    return manifestArray;
                }
            }
        }
        public override byte[] Content
        {
            get
            {
                string content = @"<?xml version=""1.0"" encoding=""UTF-8""?>

<office:document-content xmlns:office=""urn:oasis:names:tc:opendocument:xmlns:office:1.0"" xmlns:style=""urn:oasis:names:tc:opendocument:xmlns:style:1.0"" xmlns:text=""urn:oasis:names:tc:opendocument:xmlns:text:1.0"" xmlns:table=""urn:oasis:names:tc:opendocument:xmlns:table:1.0"" xmlns:draw=""urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"" xmlns:fo=""urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"" xmlns:xlink=""http://www.w3.org/1999/xlink"" xmlns:dc=""http://purl.org/dc/elements/1.1/"" xmlns:meta=""urn:oasis:names:tc:opendocument:xmlns:meta:1.0"" xmlns:number=""urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"" xmlns:svg=""urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"" xmlns:chart=""urn:oasis:names:tc:opendocument:xmlns:chart:1.0"" xmlns:dr3d=""urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"" xmlns:math=""http://www.w3.org/1998/Math/MathML"" xmlns:form=""urn:oasis:names:tc:opendocument:xmlns:form:1.0"" xmlns:script=""urn:oasis:names:tc:opendocument:xmlns:script:1.0"" xmlns:ooo=""http://openoffice.org/2004/office"" xmlns:ooow=""http://openoffice.org/2004/writer"" xmlns:oooc=""http://openoffice.org/2004/calc"" xmlns:dom=""http://www.w3.org/2001/xml-events"" xmlns:xforms=""http://www.w3.org/2002/xforms"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:rpt=""http://openoffice.org/2005/report"" xmlns:of=""urn:oasis:names:tc:opendocument:xmlns:of:1.2"" xmlns:xhtml=""http://www.w3.org/1999/xhtml"" xmlns:grddl=""http://www.w3.org/2003/g/data-view#"" xmlns:tableooo=""http://openoffice.org/2009/table"" xmlns:field=""urn:openoffice:names:experimental:ooo-ms-interop:xmlns:field:1.0"" office:version=""1.2"">
 <office:scripts/>
 <office:font-face-decls>
  <style:font-face style:name=""Mangal1"" svg:font-family=""Mangal""/>
  <style:font-face style:name=""Times New Roman"" svg:font-family=""&apos;Times New Roman&apos;"" style:font-family-generic=""roman"" style:font-pitch=""variable""/>
  <style:font-face style:name=""Arial"" svg:font-family=""Arial"" style:font-family-generic=""swiss"" style:font-pitch=""variable""/>
  <style:font-face style:name=""Arial1"" svg:font-family=""Arial"" style:font-adornments=""Normal"" style:font-family-generic=""swiss"" style:font-pitch=""variable""/>
  <style:font-face style:name=""Mangal"" svg:font-family=""Mangal"" style:font-family-generic=""system"" style:font-pitch=""variable""/>
  <style:font-face style:name=""Microsoft YaHei"" svg:font-family=""&apos;Microsoft YaHei&apos;"" style:font-family-generic=""system"" style:font-pitch=""variable""/>
  <style:font-face style:name=""SimSun"" svg:font-family=""SimSun"" style:font-family-generic=""system"" style:font-pitch=""variable""/>
 </office:font-face-decls>
 <office:automatic-styles>
  <style:style style:name=""TabelaEmpresa"" style:family=""table"">
   <style:table-properties style:width=""17cm"" table:align=""margins""/>
  </style:style>
  <style:style style:name=""TabelaEmpresa.A"" style:family=""table-column"">
   <style:table-column-properties style:column-width=""8.5cm"" style:rel-column-width=""32767*""/>
  </style:style>
  <style:style style:name=""TabelaEmpresa.B1"" style:family=""table-cell"">
   <style:table-cell-properties style:vertical-align=""middle""/>
  </style:style>
  <style:style style:name=""P1"" style:family=""paragraph"" style:parent-style-name=""Table_20_Contents"">
   <style:paragraph-properties fo:text-align=""center"" style:justify-single-word=""false""/>
  </style:style>
  <style:style style:name=""T1"" style:family=""text"">
   <style:text-properties style:text-position=""sub 58%""/>
  </style:style>
  <style:style style:name=""T2"" style:family=""text"">
   <style:text-properties style:text-position=""super 58%""/>
  </style:style>
 </office:automatic-styles>
 <office:body>
  <office:text>
   <text:sequence-decls>
    <text:sequence-decl text:display-outline-level=""0"" text:name=""Illustration""/>
    <text:sequence-decl text:display-outline-level=""0"" text:name=""Table""/>
    <text:sequence-decl text:display-outline-level=""0"" text:name=""Text""/>
    <text:sequence-decl text:display-outline-level=""0"" text:name=""Drawing""/>
   </text:sequence-decls>
   <table:table table:name=""TabelaEmpresa"" table:style-name=""TabelaEmpresa"">
    <table:table-column table:style-name=""TabelaEmpresa.A"" table:number-columns-repeated=""2""/>
    <table:table-row>
     <table:table-cell office:value-type=""string"">
      <text:p text:style-name=""Table_20_Contents""/>
     </table:table-cell>
     <table:table-cell table:style-name=""TabelaEmpresa.B1"" table:number-rows-spanned=""3"" office:value-type=""string"">
      <text:p text:style-name=""P1"">Imagem</text:p>
     </table:table-cell>
    </table:table-row>
    <table:table-row>
     <table:table-cell office:value-type=""string"">
      <text:p text:style-name=""Table_20_Contents""/>
     </table:table-cell>
     <table:covered-table-cell/>
    </table:table-row>
    <table:table-row>
     <table:table-cell office:value-type=""string"">
      <text:p text:style-name=""Table_20_Contents""/>
     </table:table-cell>
     <table:covered-table-cell/>
    </table:table-row>
   </table:table>
   <text:h text:style-name=""Heading_20_1"" text:outline-level=""1"">Relatório de ensaio</text:h>
   <text:p text:style-name=""Standard"">Data do ensaio: 20/08/2012 14:17</text:p>
   <text:p text:style-name=""Standard""/>
   <text:p text:style-name=""Standard"">Descrição do ensaio: Ensaio de Tração</text:p>
   <text:p text:style-name=""Standard""/>
   <text:p text:style-name=""Standard"">Imagem</text:p>
   <text:p text:style-name=""Standard""/>
   <text:p text:style-name=""Standard"">Força máxima (F<text:span text:style-name=""T1"">M</text:span>): 121212 kgf</text:p>
   <text:p text:style-name=""Standard"">Tensão máxima: </text:p>
   <text:p text:style-name=""Standard"">Área (S<text:span text:style-name=""T1"">0</text:span>): 48,00 mm<text:span text:style-name=""T2"">2</text:span></text:p>
   <text:p text:style-name=""Standard""><text:span text:style-name=""T2""/></text:p>
  </office:text>
 </office:body>
</office:document-content>";
                byte[] contentArray = Encoding.UTF8.GetBytes(content);
                return contentArray;
            }
        }
        public byte[] Styles
        {
            get
            {
                {
                    string styles = @"<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>
<office:document-styles xmlns:anim=""urn:oasis:names:tc:opendocument:xmlns:animation:1.0"" xmlns:chart=""urn:oasis:names:tc:opendocument:xmlns:chart:1.0"" xmlns:config=""urn:oasis:names:tc:opendocument:xmlns:config:1.0"" xmlns:dc=""http://purl.org/dc/elements/1.1/"" xmlns:dr3d=""urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"" xmlns:draw=""urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"" xmlns:fo=""urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"" xmlns:form=""urn:oasis:names:tc:opendocument:xmlns:form:1.0"" xmlns:math=""http://www.w3.org/1998/Math/MathML"" xmlns:meta=""urn:oasis:names:tc:opendocument:xmlns:meta:1.0"" xmlns:number=""urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"" xmlns:office=""urn:oasis:names:tc:opendocument:xmlns:office:1.0"" xmlns:presentation=""urn:oasis:names:tc:opendocument:xmlns:presentation:1.0"" xmlns:script=""urn:oasis:names:tc:opendocument:xmlns:script:1.0"" xmlns:smil=""urn:oasis:names:tc:opendocument:xmlns:smil-compatible:1.0"" xmlns:style=""urn:oasis:names:tc:opendocument:xmlns:style:1.0"" xmlns:svg=""urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"" xmlns:table=""urn:oasis:names:tc:opendocument:xmlns:table:1.0"" xmlns:text=""urn:oasis:names:tc:opendocument:xmlns:text:1.0"" xmlns:xforms=""http://www.w3.org/2002/xforms"" xmlns:xlink=""http://www.w3.org/1999/xlink"">
	<office:font-face-decls>
		<style:font-face style:name=""Calibri"" svg:font-family=""Calibri"" style:font-family-generic=""swiss"" style:font-pitch=""variable"" svg:panose-1=""2 15 5 2 2 2 4 3 2 4""/>
		<style:font-face style:name=""Times New Roman"" svg:font-family=""Times New Roman"" style:font-family-generic=""roman"" style:font-pitch=""variable"" svg:panose-1=""2 2 6 3 5 4 5 2 3 4""/>
		<style:font-face style:name=""Arial"" svg:font-family=""Arial"" style:font-family-generic=""swiss"" style:font-pitch=""variable"" svg:panose-1=""2 11 6 4 2 2 2 2 2 4""/>
		<style:font-face style:name=""Cambria"" svg:font-family=""Cambria"" style:font-family-generic=""roman"" style:font-pitch=""variable"" svg:panose-1=""2 4 5 3 5 4 6 3 2 4""/>
	</office:font-face-decls>
	<office:styles>
		<style:default-style style:family=""table"">
			<style:table-properties fo:margin-left=""0in"" table:border-model=""collapsing"" style:writing-mode=""lr-tb"" table:align=""left""/>
		</style:default-style>
		<style:default-style style:family=""table-column"">
			<style:table-column-properties style:use-optimal-column-width=""true""/>
		</style:default-style>
		<style:default-style style:family=""table-row"">
			<style:table-row-properties style:min-row-height=""0in"" style:use-optimal-row-height=""true"" fo:keep-together=""auto""/>
		</style:default-style>
		<style:default-style style:family=""table-cell"">
			<style:table-cell-properties fo:background-color=""transparent"" style:glyph-orientation-vertical=""auto"" style:vertical-align=""top"" fo:wrap-option=""wrap""/>
		</style:default-style>
		<style:default-style style:family=""paragraph"">
			<style:paragraph-properties fo:keep-with-next=""auto"" fo:keep-together=""auto"" fo:widows=""2"" fo:orphans=""2"" fo:break-before=""auto"" text:number-lines=""true"" fo:border=""none"" fo:padding=""0in"" style:shadow=""none"" style:line-break=""strict"" style:punctuation-wrap=""hanging"" style:text-autospace=""ideograph-alpha"" style:snap-to-layout-grid=""true"" fo:text-align=""start"" style:writing-mode=""lr-tb"" fo:line-height=""100%"" fo:background-color=""transparent"" style:tab-stop-distance=""0.4916in""/>
			<style:text-properties style:font-name=""Calibri"" style:font-name-asian=""Calibri"" style:font-name-complex=""Times New Roman"" fo:font-weight=""normal"" style:font-weight-asian=""normal"" style:font-weight-complex=""normal"" fo:font-style=""normal"" style:font-style-asian=""normal"" style:font-style-complex=""normal"" fo:text-transform=""none"" fo:font-variant=""normal"" style:text-line-through-type=""none"" style:text-outline=""false"" fo:text-shadow=""none"" style:font-relief=""none"" style:use-window-font-color=""true"" fo:letter-spacing=""normal"" style:text-scale=""100%"" style:letter-kerning=""false"" style:text-position=""0% 100%"" fo:font-size=""10pt"" style:font-size-asian=""10pt"" style:font-size-complex=""10pt"" fo:background-color=""transparent"" style:text-underline-type=""none"" style:text-underline-color=""font-color"" style:text-emphasize=""none"" fo:language=""pt"" fo:country=""BR"" style:language-asian=""pt"" style:country-asian=""BR"" style:language-complex=""ar"" style:country-complex=""SA"" style:text-combine=""none"" fo:hyphenate=""true""/>
		</style:default-style>
		<style:style style:name=""Normal"" style:display-name=""Normal"" style:family=""paragraph"">
			<style:paragraph-properties fo:margin-bottom=""0.1388in"" fo:line-height=""115%""/>
			<style:text-properties fo:font-size=""11pt"" style:font-size-asian=""11pt"" style:font-size-complex=""11pt"" style:language-asian=""en"" style:country-asian=""US"" fo:hyphenate=""false""/>
		</style:style>
		<style:style style:name=""Fonteparág.padrão"" style:display-name=""Fonte parág. padrão"" style:family=""text""/>
		<text:notes-configuration text:note-class=""footnote"" text:start-value=""0"" style:num-format=""1"" text:start-numbering-at=""document"" text:footnotes-position=""page""/>
		<text:notes-configuration text:note-class=""endnote"" text:start-value=""0"" style:num-format=""i"" text:start-numbering-at=""document"" text:footnotes-position=""document""/>
		<style:style style:family=""graphic"" style:name=""Graphics""/>
		<style:default-style style:family=""graphic"">
			<style:graphic-properties draw:fill=""solid"" draw:fill-color=""#4f81bd"" draw:opacity=""100%"" draw:stroke=""solid"" svg:stroke-width=""0.02778in"" svg:stroke-color=""#385d8a"" svg:stroke-opacity=""100%""/>
		</style:default-style>
	</office:styles>
	<office:automatic-styles>
		<style:page-layout style:name=""PL0"">
			<style:page-layout-properties fo:page-width=""8.268in"" fo:page-height=""11.693in"" style:print-orientation=""portrait"" fo:margin-top=""0.984in"" fo:margin-left=""1.1812in"" fo:margin-bottom=""0.984in"" fo:margin-right=""1.1812in"" style:num-format=""1"" style:writing-mode=""lr-tb"">
				<style:footnote-sep style:width=""0.007in"" style:rel-width=""33%"" style:color=""#000000"" style:line-style=""solid"" style:adjustment=""left""/>
			</style:page-layout-properties>
		</style:page-layout>
	</office:automatic-styles>
	<office:master-styles>
		<style:master-page style:name=""MP0"" style:page-layout-name=""PL0""/>
	</office:master-styles>
</office:document-styles>";
                    byte[] stylesArray = Encoding.UTF8.GetBytes(styles);
                    return stylesArray;
                }
            }
        }

        public RelatorioODTEnsaioTracao(EnsaioTracao ensaio)
        {
            this._ensaio = ensaio;
            this._items = new Dictionary<String, byte[]>
            {
                {"/content.xml", this.Content},
                {"/styles.xml", this.Styles},
                {"/meta.xml", this.Meta},
                {"/META-INF/manifest.xml", this.Manifest},
            };
        }

        public override Dictionary<string, byte[]> Items
        {
            get {
                return this._items;
            }
        }
    }
}
