﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace TestView.Dados
{
    public class ConexaoBD
    {
        #region Construtor e membros

        private SqlConnection _conexao;
        private Boolean _emUtilizacao;

        public ConexaoBD(string stringConexao)
        {
            this._conexao = new SqlConnection(stringConexao);
            this._emUtilizacao = false;
        }

        private SqlConnection Conexao
        {
            get
            {
                return this._conexao;
            }
        }

        public Boolean EmUtilizacao
        {
            get
            {
                return this._emUtilizacao;
            }
            set
            {
                this._emUtilizacao = value;
            }
        }

        #region Utilizacao

        public int executaComandoSemRetorno(string sql)
        {
            return this.executaComandoSemRetorno(sql, string.Empty);
        }

        public int executaComandoSemRetorno(string sql, string nomeTransacao)
        {
            SqlConnection conexao = this._conexao;
            conexao.Open();
            SqlTransaction transacao = this._conexao.BeginTransaction(nomeTransacao);
            SqlCommand comando = conexao.CreateCommand();
            comando.Connection = conexao;
            comando.Transaction = transacao;
            comando.CommandText = sql;
            int linhasAfetadas = comando.ExecuteNonQuery();
            transacao.Commit();
            conexao.Close();
            return linhasAfetadas;
        }

        public DataTable executaComando(string sql)
        {
            return this.executaComando(sql, string.Empty);
        }

        public DataTable executaComando(string sql, string nomeTransacao)
        {
            SqlConnection conexao = this._conexao;
            conexao.Open();
            SqlTransaction transacao = this._conexao.BeginTransaction(nomeTransacao);
            SqlCommand comando = conexao.CreateCommand();
            comando.Connection = conexao;
            comando.Transaction = transacao;
            comando.CommandText = sql;
            SqlDataReader reader = comando.ExecuteReader();
            
            DataTable esquemaResultado = reader.GetSchemaTable();
            DataTable tabelaResultado = new DataTable();

            for (int i = 0; i < esquemaResultado.Rows.Count; i++)
            {
                DataColumn novaColuna = new DataColumn();
                if (!tabelaResultado.Columns.Contains(esquemaResultado.Rows[i]["ColumnName"].ToString()))
                {
                    novaColuna.ColumnName = esquemaResultado.Rows[i]["ColumnName"].ToString();
                    novaColuna.Unique = Convert.ToBoolean(esquemaResultado.Rows[i]["IsUnique"]);
                    novaColuna.AllowDBNull = Convert.ToBoolean(esquemaResultado.Rows[i]["AllowDBNull"]);
                    novaColuna.ReadOnly = Convert.ToBoolean(esquemaResultado.Rows[i]["IsReadOnly"]);
                    tabelaResultado.Columns.Add(novaColuna);
                }
            }

            while (reader.Read())
            {
                DataRow novaLinha = tabelaResultado.NewRow();
                for (int i = 0; i < tabelaResultado.Columns.Count; i++)
                {
                    novaLinha[i] = reader.GetValue(i);
                }
                tabelaResultado.Rows.Add(novaLinha);
            }

            reader.Close();
            transacao.Commit();
            conexao.Close();
            return tabelaResultado;
        }

        #endregion

        #endregion
    }
}
