﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace TestView.Ensaios
{
    public class BibliotecaModulo
    {
        public static readonly BibliotecaModulo BIBLIOTECA_ELASTICIDADE = new BibliotecaModulo("elasticidade", "Módulo de elasticidade", "ModuloEnsaioElasticidade.ModuloEnsaioElasticidade", null);
        public static readonly BibliotecaModulo BIBLIOTECA_TRACAO = new BibliotecaModulo("tracao", "Módulo de tração", "ModuloEnsaioTracao.ModuloEnsaioTracao", null);

        #region Construtor e membros

        private string _nomeBiblioteca;
        private string _descricaoModulo;
        private string _nomeClasseModulo;
        private string _nomeClasseEnsaio;
        private Assembly _assembly;

        public BibliotecaModulo(string nomeBiblioteca, string descricao, string nomeClasseModulo, string nomeClasseEnsaio)
        {
            this._nomeBiblioteca = nomeBiblioteca;
            this._descricaoModulo = descricao;
            this._nomeClasseModulo = nomeClasseModulo;
            this._nomeClasseEnsaio = nomeClasseEnsaio;
        }

        public String NomeBiblioteca
        {
            get
            {
                return this._nomeBiblioteca;
            }
        }

        public string DescricaoModulo
        {
            get
            {
                return this._descricaoModulo;
            }
        }

        public String NomeClasseModulo
        {
            get
            {
                return this._nomeClasseModulo;
            }
        }

        public String NomeClasseEnsaio
        {
            get
            {
                return this._nomeClasseEnsaio;
            }
        }

        public Assembly Assembly
        {
            get
            {
                return this._assembly;
            }
            set
            {
                this._assembly = value;
            }
        }

        #endregion

        #region Carregador

        public void carregaBiblioteca()
        {
            Assembly assembly = Assembly.Load(this.NomeBiblioteca);
            this.Assembly = assembly;
        }

        public IModuloDeEnsaio obtemNovaInstanciaModulo()
        {
            Type tipo = this.Assembly.GetType(this.NomeClasseModulo);
            IModuloDeEnsaio modulo = (IModuloDeEnsaio)Activator.CreateInstance(tipo);
            return modulo;
        }

        #endregion
    }
}
