﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios.Utilidades.CorposDeProva;
using System.Runtime.Serialization;
using System.IO;
using TestView.Ensaios.Utilidades.Coleta;
using TestView.Relatorios;

namespace TestView.Ensaios
{
    [DataContract]
    public abstract class Ensaio
    {
        #region Ensaio

        [DataMember]
        public String Id
        {
            get;
            set;
        }
        [DataMember]
        public abstract EstadoEnsaio EstadoEnsaio
        {
            get;
            set;
        }
        [DataMember]
        public abstract DateTime DataEnsaio
        {
            get;
            set;
        }
        [DataMember]
        public abstract CorpoDeProva CorpoDeProva
        {
            get;
            set;
        }
        [DataMember]
        public abstract Aquisicao Aquisicao
        {
            get;
            set;
        }
        public abstract Relatorio Relatorio
        {
            get;
        }

        #endregion

        #region Serializacao

        public abstract void serializaEnsaio(Stream stream);

        public abstract Ensaio deserializaEnsaio(Stream stream);

        #endregion

        #region Eventos

        #region Estado do ensaio

        public delegate void EstadoEnsaioChangedEvent(object sender, EstadoEnsaioEventArgs e);

        public event EstadoEnsaioChangedEvent EstadoEnsaioChanged;

        public class EstadoEnsaioEventArgs : EventArgs
        {
            public EstadoEnsaioEventArgs(EstadoEnsaio estadoEnsaio)
            {
                this.EstadoEnsaio = estadoEnsaio;
            }

            public EstadoEnsaio EstadoEnsaio
            {
                get;
                set;
            }
        }

        protected void informEstadoEnsaioListeners()
        {
            if (EstadoEnsaioChanged != null)
            {
                EstadoEnsaioChanged(this, new EstadoEnsaioEventArgs(this.EstadoEnsaio));
            }
        }

        #endregion

        #endregion
    }
}
