﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace TestView.Ensaios.Utilidades.CorposDeProva
{
    [DataContract]
    public abstract class CorpoDeProva : ICloneable
    {
        #region Membros

        public abstract string Nome
        {
            get;
        }

        public abstract double AreaEquivalente
        {
            get;
        }

        #endregion

        #region Misc.

        public abstract object Clone();

        public override string ToString()
        {
            return this.Nome;
        }

        #endregion

        #region Eventos

        #region ConexaoChanged

        public delegate void CorpoDeProvaChangedEvent(object sender, CorpoDeProvaChangedEventArgs e);

        public event CorpoDeProvaChangedEvent CorpoDeProvaChanged;

        public class CorpoDeProvaChangedEventArgs : EventArgs
        {
            public CorpoDeProvaChangedEventArgs()
            {
            }
        }

        protected void informCorpoDeProvaListeners()
        {
            if (CorpoDeProvaChanged != null)
            {
                CorpoDeProvaChanged(this, new CorpoDeProvaChangedEventArgs());
            }
        }

        #endregion

        #endregion
    }
}
