﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.IO;

namespace TestView.Seguranca
{
    public class Criptografia
    {
        #region Construtor e membros

        private static Criptografia _instancia;
        private Rijndael _rijndaelAlg;

        private byte[] _vetorInicializacao;
        private byte[] _frase;

        public static Criptografia getInstance()
        {
            if (_instancia == null)
            {
                _instancia = new Criptografia();
            }
            return _instancia;
        }

        public Criptografia() 
        {
            this._vetorInicializacao = new byte[] { 0x50, 0x08, 0xF1, 0xDD, 0xDE, 0x3C, 0xF2, 0x18, 0x44, 0x74, 0x19, 0x2C, 0x53, 0x49, 0xAB, 0xBC };

            this._frase = Encoding.ASCII.GetBytes("Testview Dinateste Ind E Com Ltd");
            this._rijndaelAlg = Rijndael.Create();
            this._rijndaelAlg.KeySize = 256;
        }

        public String encriptar(String texto)
        {
            byte[] bytesTexto = Encoding.Unicode.GetBytes(texto);
            return this.encriptar(bytesTexto);
        }

        public String encriptar(byte[] objeto)
        {
            MemoryStream stream = new MemoryStream();
            ICryptoTransform encriptador = this._rijndaelAlg.CreateEncryptor(this._frase, this._vetorInicializacao);
            CryptoStream streamEncript = new CryptoStream(stream, encriptador, CryptoStreamMode.Write);
            streamEncript.Write(objeto, 0, objeto.Length);
            streamEncript.FlushFinalBlock();
            String cripto = Convert.ToBase64String(stream.ToArray());
            return cripto;
        }

        public String decriptar(String texto)
        {
            byte[] bytesTexto = Convert.FromBase64String(texto);
            return this.decriptar(bytesTexto);
        }

        public String decriptar(byte[] cripto)
        {
            MemoryStream stream = new MemoryStream();
            ICryptoTransform decriptador = this._rijndaelAlg.CreateDecryptor(this._frase, this._vetorInicializacao);
            CryptoStream streamDecript = new CryptoStream(stream, decriptador, CryptoStreamMode.Write);
            streamDecript.Write(cripto, 0, cripto.Length);
            streamDecript.FlushFinalBlock();
            String texto = Encoding.Unicode.GetString(stream.ToArray());
            return texto;
        }

        #endregion
    }
}
