﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TestView.Ensaios;
using System.Drawing.Imaging;
using System.Drawing.Printing;
using TestView.Seguranca;

namespace TestViewGUI.Relatorios
{
    public partial class FormVisualizarRelatorio : Form
    {
        #region Construtor e membros

        private IModuloDeEnsaio _moduloEnsaio;
        private Form _formRelatorio;
        private Panel _painelRelatorio;
        private IModuloDeEnsaio ModuloEnsaio
        {
            get
            {
                return this._moduloEnsaio;
            }
        }
        private IModuloGUI ModuloGUI
        {
            get
            {
                return this._moduloEnsaio.FachadaGUI;
            }
        }

        public FormVisualizarRelatorio(IModuloDeEnsaio moduloEnsaio)
        {
            InitializeComponent();
            this._moduloEnsaio = moduloEnsaio;
            this._formRelatorio = this.ModuloGUI.FormRelatorio;
            this.inicializaPainelRelatorio();
        }

        #endregion

        #region Layout

        private void inicializaPainelRelatorio()
        {
            this._painelRelatorio = new Panel();
            this._painelRelatorio.Size = this._formRelatorio.Size;
            foreach (Control controle in this._formRelatorio.Controls)
            {
                this._painelRelatorio.Controls.Add(controle);
            }
            this._painelRelatorio.BorderStyle = BorderStyle.FixedSingle;
            this._painelRelatorio.BackColor = Color.White;
            this.centralizaPainelRelatorio();
            this.Controls.Add(this._painelRelatorio);
        }

        private void centralizaPainelRelatorio()
        {
            this._painelRelatorio.Location = new Point((this.Size.Width - this._painelRelatorio.Size.Width) / 2, (this.Size.Height - this._painelRelatorio.Size.Height) / 2);
        }

        #endregion

        #region Eventos

        private void FormVisualizarRelatorio_Resize(object sender, EventArgs e)
        {
            this.centralizaPainelRelatorio();
        }

        private void fecharToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        #endregion

        private void imprimirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormOpcoesImpressao form = new FormOpcoesImpressao(this._moduloEnsaio);
            form.ShowDialog();
        }
    }
}
